﻿;form1

Declare F1AddRecord()
Declare F1DeleteRecord()
Declare F1EditRecord()
Declare F1RefreshForm()
Declare F1FillForm()
Declare F1About()
Declare F1StoreForm()
Declare F1RestoreForm()

IncludeFile "form2.pb"
IncludeFile "form3.pb"

Enumeration FormMenu
  #F1keyEditRecord
EndEnumeration

;=== begin: Form Designer code

Global F1Form, F1Menu, F1ToolBar, F1StatusBar

Global F1lstContacts

Global Img_F1Form_0, Img_F1Form_1, Img_F1Form_2

Enumeration FormMenu
  #F1menuAbout
  #F1barAddRecord
  #F1barDeleteRecord
  #F1barRefresh
EndEnumeration

Img_F1Form_0 = LoadImage(#PB_Any,"add.ico")
Img_F1Form_1 = LoadImage(#PB_Any,"delete.ico")
Img_F1Form_2 = LoadImage(#PB_Any,"refresh.ico")


Procedure OpenF1Form(x = 0, y = 0, width = 600, height = 430)
; commented lines are before tweaking Form Designer code
  F1Form = OpenWindow(#PB_Any, x, y, width, height, "Contact Manager v0.0 Form1", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
;  CreateToolBar(0, WindowID(F1Form))
  F1ToolBar = CreateToolBar(#PB_Any, WindowID(F1Form), #PB_ToolBar_Large)
  ToolBarImageButton(#F1barAddRecord,ImageID(Img_F1Form_0))
  ToolBarImageButton(#F1barDeleteRecord,ImageID(Img_F1Form_1))
  ToolBarImageButton(#F1barRefresh,ImageID(Img_F1Form_2))
;  CreateStatusBar(0, WindowID(F1Form))
  F1StatusBar = CreateStatusBar(#PB_Any, WindowID(F1Form))
  AddStatusBarField(#PB_Ignore)
;  CreateMenu(0, WindowID(F1Form))
  F1Menu = CreateMenu(#PB_Any, WindowID(F1Form))
  MenuTitle("&Help")
  MenuItem(#F1menuAbout, "&About")
;  F1lstContacts = ListIconGadget(#PB_Any, 0, ToolBarHeight(0) + 0, 600, 375, "  ID", 34, #PB_ListIcon_GridLines | #PB_ListIcon_FullRowSelect)
 F1lstContacts = ListIconGadget(#PB_Any, 0, ToolBarHeight(F1ToolBar) + 0, 600, 375, "  ID", 34, #PB_ListIcon_GridLines | #PB_ListIcon_FullRowSelect)
  AddGadgetColumn(F1lstContacts, 1, "Contact Name", 255)
  AddGadgetColumn(F1lstContacts, 2, "Phone", 120)
  AddGadgetColumn(F1lstContacts, 3, "Email", 200)
EndProcedure

;=== end: Form Designer code

Procedure F1HandleForm()
  OpenF1Form()
  AddMapElement(AppData\Forms(), Str(F1form))
  F1StoreForm()
  AddKeyboardShortcut(F1Form, #PB_Shortcut_Insert, #F1barAddRecord)
  AddKeyboardShortcut(F1Form, #PB_Shortcut_Delete, #F1barDeleteRecord)
  AddKeyboardShortcut(F1Form, #PB_Shortcut_Return, #F1keyEditRecord)
  AddKeyboardShortcut(F1Form, #PB_Shortcut_F5, #F1barRefresh)
  QueryContacts("SELECT * FROM Contacts")
  If ListSize(ContactsList()) = 0
    F1AddRecord()
  Else
    F1FillForm()
    SetActiveGadget(F1lstcontacts)
    SetGadgetItemState(F1lstContacts, 0, #PB_ListIcon_Selected)
  EndIf
  Define WinEvent.i
  Define EventWin.i
  Repeat
    WinEvent = WaitWindowEvent()
    EventWin = EventWindow()
    FindMapElement(AppData\Forms(), Str(EventWin))
    Select AppData\Forms()\Name
      Case "form1"
        F1form = EventWin
        F1RestoreForm()
        Select WinEvent
          Case #PB_Event_CloseWindow
            CloseWindow(F1Form)
            ProcedureReturn
          Case #PB_Event_Menu
            Select EventMenu()
              Case #F1barAddRecord
                F1AddRecord()
              Case #F1barDeleteRecord
                F1DeleteRecord()
              Case #F1keyEditRecord
                F1EditRecord()
              Case #F1barRefresh
                F1RefreshForm()
              Case #F1menuAbout
                F1About()
            EndSelect
          Case #PB_Event_Gadget
            Select EventGadget()
              Case F1lstContacts
                Select EventType()
                  Case #PB_EventType_LeftDoubleClick
                    F1EditRecord()
                EndSelect
            EndSelect
        EndSelect
      Case "form2"
        Shared F2CurrentMode
        F2form = EventWin
        F2RestoreForm()
        Select WinEvent
          Case #PB_Event_CloseWindow
            DeleteMapElement(AppData\Forms(), Str(F2form))
            CloseWindow(F2form)
          Case #PB_Event_Menu
            Select EventMenu()
              Case #F2barFirstRec
                F2MoveTo(#F2NavFirst)
              Case #F2barPrevRec
                F2MoveTo(#F2NavPrev)
              Case #F2barNextRec
                F2MoveTo(#F2NavNext)
              Case #F2barLastRec
                F2MoveTo(#F2NavLast)
              Case #F2barAddRec
                F2AddRecord()
              Case #F2barDeleteRec
                F2DeleteRecord()
              Case #F2barSaveRec
                F2SaveRecord()
              Case #F2barCancel
                F2CancelEdit()
            EndSelect
          Case #PB_Event_Gadget
            Select EventType()
              Case #PB_EventType_Focus
                  F2EnterForm()
            EndSelect
        EndSelect
    EndSelect
  ForEver
EndProcedure

Procedure F1AddRecord()
  ContactsRecord\ID = 0
  F2HandleForm()
EndProcedure

Procedure F1EditRecord()
  ContactsRecord\ID = Val(GetGadgetText(F1lstContacts))
  If ContactsRecord\ID > 0
    SelectElement(ContactsList(), GetGadgetState(F1lstContacts))
    GetContacts()
    F2HandleForm()
  EndIf
EndProcedure

Procedure F1DeleteRecord()
  ContactsRecord\ID = Val(GetGadgetText(F1lstContacts))
  If ContactsRecord\ID > 0
    SelectElement(ContactsList(), GetGadgetState(F1lstContacts))
    GetContacts()
    DisableWindow(F1Form, #True)
    F2HandleForm()
    If MessageRequester("Caution", "Do you wish to delete this record? ", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
      DeleteContacts()
      DeleteMapElement(AppData\Forms(), Str(F2Form))
    EndIf
    CloseWindow(F2Form)
    DisableWindow(F1Form, #False)
    F1FillForm()
    If ListSize(ContactsList()) = 0
      F1AddRecord()
    EndIf
  EndIf
EndProcedure

Procedure F1RefreshForm()
  QueryContacts("SELECT * FROM Contacts")
  F1FillForm()
EndProcedure

Procedure F1FillForm()
  ClearGadgetItems(F1lstContacts)
  If ListSize(ContactsList()) > 0
    ResetList(ContactsList())
    While NextElement(ContactsList())
      ContactsRecord = ContactsList()
      AddGadgetItem(F1lstContacts, -1,
                    RSet(Trim(FormatNumber(ContactsRecord\ID, 0)), 4, "0") + Chr(10) +
                    ContactsRecord\FullName + Chr(10) +
                    ContactsRecord\Phone + Chr(10) +
                    ContactsRecord\Email + Chr(10))
    Wend
    SetActiveGadget(F1lstcontacts)
    SetGadgetItemState(F1lstContacts, 0, #PB_ListIcon_Selected)
  EndIf
EndProcedure

Procedure F1About()
    DisableWindow(F1Form, #True)
    F3HandleForm()
    DisableWindow(F1Form, #False)
    SetActiveWindow(F1Form)
EndProcedure
  
Procedure F1StoreForm()
  AppData\Forms()\Name = "form1"
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F1Menu
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F1ToolBar
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F1StatusBar
  AddElement(AppData\Forms()\Gadgets())
  AppData\Forms()\Gadgets() = F1lstContacts
EndProcedure

Procedure F1RestoreForm()
  ResetList(AppData\Forms()\Gadgets())
  NextElement (AppData\Forms()\Gadgets())
  F1Menu = AppData\Forms()\Gadgets()
  NextElement (AppData\Forms()\Gadgets())
  F1ToolBar = AppData\Forms()\Gadgets()
  NextElement (AppData\Forms()\Gadgets())
  F1StatusBar = AppData\Forms()\Gadgets()
  NextElement (AppData\Forms()\Gadgets())
  F1lstContacts = AppData\Forms()\Gadgets()
EndProcedure
